#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include "parser.h"

struct anchor
{
	struct anchor *link;
	char *key;
	int y;
};

static struct anchor *anchors;

/*
 *	Flush the anchor areas
 */	
 
void free_anchors(void)
{
	struct anchor *a;
	
	while(anchors!=NULL)
	{
		a = anchors;
		anchors = anchors->link;
		free(a);
	}
	anchors = NULL;
}

/*
 *	Find matching anchor
 */			
 
int find_anchor(char *name)
{
	struct anchor *a = anchors;

	while(a!=NULL)
	{
		if(strcasecmp(a->key, name)==0)
			return a->y;
		a=a->link;
	}
	return 0;
}

void add_anchor(char *name, int y)
{
	struct anchor *a = (struct anchor *)malloc(sizeof(*a));

	/* The data is persistent until document destruction so no copy */	
	a->key = name;
	a->y = y;

	a->link = anchors;
	anchors = a;
}
