/*
 *	Simple HTML rendering engine
 *
 *	Example and test ACII output engine
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>

unsigned char lastnl = 1;
unsigned char wordp;
unsigned char pos;

static char wordbuf[64];

static void flush_word(void)
{
	if(wordp)
	{
		wordbuf[wordp]=0;
		printf("%s", wordbuf);
		pos+=wordp;
		if(pos!=39)
		{
			printf(" ");
			pos++;
		}
		wordp=0;
		lastnl=0;
	}
}

void render_text(char *p)
{
	while(*p)
	{
		if(isspace(*p))
			flush_word();
		else 
		{
			if(wordp == 40)
				flush_word();
			else if(pos+wordp>39)
			{
				printf("\n");
				pos=0;
				lastnl=1;
			}
			wordbuf[wordp++]=*p;
		}
		p++;
	}
}


void renderer_reset(void)
{
	lastnl = 1;
	wordp = 0;
	pos = 0;
}

void renderer_begin(void)
{
	printf("\033[0;0H\033[J");
}


void render_newline(void)
{
	flush_word();
	printf("\n");
	lastnl=1;
	pos=0;
}

void render_newline_p(void)
{
	flush_word();
	if(lastnl==0)
		render_newline();
}

void renderer_complete(void)
{
	render_newline_p();
}

