extern void parser_debug(char *p);
extern void parser_fatal(char *p);
extern void parser_warning(char *p);

struct token_attr
{
	struct token_attr *next;
	char *key;
	char *val;
};

struct tag_render;

struct token_stack
{
	struct token_stack *next;	/* Subtree */
	struct token_stack *link;	/* Next in tree */
	char *tag;
	struct token_attr *attr;
	char *data;
	unsigned long rval;		/* Renderer stacked state */
	struct tag_render *render;
	unsigned char done;
};

struct tag_render
{
	char *tag;
	void (*begin)(struct token_stack *t);
	void (*end)(struct token_stack *t);
};

/*
 *	Renderer state -  6 bytes currently
 */
 
struct render_state
{
	unsigned int rfont:5;
#define RF_LINK		1
#define RF_BOLD		2
#define RF_BQUOTE	4
#define RF_PLAIN	8
#define RF_HIDE		16
	unsigned int rlayout:4;
#define RL_CENTRE	1
#define RL_RIGHT	2
#define RL_PRE		4
#define RL_TITLE	8
	unsigned int rlist:2;
	unsigned int rsize:3;
#define RL_DL		1
#define RL_OL		2
#define RL_UL		3
	unsigned int rbody:1;
	unsigned int rhead:1;
	unsigned char rcount;
	unsigned char rindent;
};

extern struct render_state *render;

extern struct token_stack *tokens;
extern struct token_stack *tokens_tail;
extern struct token_stack *stack;

extern void token_peek_pop(char *tag, char *until);
extern char *tag_attr(struct token_stack *token, char *key);
extern char *tag_attr_default(struct token_stack *token, char *key, char *def);

extern struct tag_render *find_renderer(char *t);
extern struct token_stack *parser(char *p);
extern void parse_complete(void);


extern void render_reset(struct render_state *r);

extern void renderer_reset(void);
extern void render_text(char *t);
extern void render_newline(void);
extern void render_newline_p(void);
extern void render_anchor(char *p);
extern void renderer_begin(struct token_stack *t);
extern void renderer_complete(struct token_stack *t);


struct link_box
{
	struct link_box *next;
	unsigned short x,y,w,h;
};

struct link_url
{
	struct link_url *next;
	struct link_url *link;
	struct token_stack *token;
	unsigned short type;
	char *data;
	struct link_box *boxes;
};

extern void link_area_begin(struct token_stack *t, int type, char *uri);
#define L_URLGOTO	1		/* Go to URL */
#define L_ANCHOR	2		/* Anchor (slight abuse but works) */
extern void link_area_end(struct token_stack *t, int type);
extern struct link_url *link_hit(int x, int y);
extern void link_free(void);
extern struct link_url *link_top(void);
extern void link_add_box(struct link_url *link, int x, int y, int w, int h);

/* Hacks for now */
extern char buf[16384];
extern char *pagebuf;

extern void load_url(void);
extern void set_base_url(char *p);

extern void mark_html_dirty(void);
extern void set_scrollbar(int y);

extern void add_anchor(char *url, int y);
extern int find_anchor(char *url);
extern void free_anchors(void);

